package gregapi.tileentity.connectors;

import static gregapi.data.CS.*;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetCollisionBoundingBoxFromPool;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnEntityCollidedWithBlock;
import gregapi.block.multitileentity.MultiTileEntityBlock;
import gregapi.block.multitileentity.MultiTileEntityRegistry;
import gregapi.code.ArrayListNoNulls;
import gregapi.code.TagData;
import gregapi.data.CS.IconsGT;
import gregapi.data.CS.SFX;
import gregapi.data.*;
import gregapi.data.LH.Chat;
import gregapi.old.Textures;
import gregapi.oredict.OreDictMaterial;
import gregapi.render.BlockTextureDefault;
import gregapi.render.BlockTextureMulti;
import gregapi.render.ITexture;
import gregapi.tileentity.data.ITileEntityGibbl;
import gregapi.tileentity.data.ITileEntityProgress;
import gregapi.tileentity.data.ITileEntityTemperature;
import gregapi.tileentity.delegate.DelegatorTileEntity;
import gregapi.util.OM;
import gregapi.util.UT;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import net.minecraft.block.BlockCauldron;
import net.minecraft.entity.Entity;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraftforge.common.util.ForgeDirection;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.FluidTank;
import net.minecraftforge.fluids.IFluidHandler;
import net.minecraftforge.fluids.IFluidTank;

/**
 * @author Gregorius Techneticies
 */
public class MultiTileEntityPipeFluid extends TileEntityBase10ConnectorRendered implements IFluidHandler, ITileEntityGibbl, ITileEntityTemperature, ITileEntityProgress, IMTE_GetCollisionBoundingBoxFromPool, IMTE_OnEntityCollidedWithBlock {
	private static double HEAT_RESISTANCE_BONUS = 1.25;
	
	public byte mLastReceivedFrom = 0, mRenderType = 0;
	public long mTemperature = DEFAULT_ENVIRONMENT_TEMPERATURE, mTransferredAmount = 0;
	public boolean mGasProof = F;
	public FluidTank mTank = new FluidTank(1000);
	
	/**
	 * Utility to quickly add a whole set of Fluid Pipes.
	 * May use up to 20 IDs, even if it is just 5 right now!
	 */
	public static void addFluidPipes(int aID, int aCreativeTabID, long aStat, boolean aGasProof, boolean aContactDamage, boolean aRecipe, MultiTileEntityRegistry aRegistry, MultiTileEntityBlock aBlock, Class aClass, OreDictMaterial aMat) {
	    OM.reg_(OP.pipeTiny				, aMat, aRegistry.add("Tiny " + aMat.getLocal() + " Fluid Pipe"				, "Fluid Pipes"				, aID   , aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   0, NBT_DIAMETER, PIXELS_POS[ 4], NBT_CONTACTDAMAGE, aContactDamage, NBT_CAPACITY, aStat   , NBT_GASPROOF, aGasProof), aRecipe?new Object[]{"sP ", "wzh"       , 'P', OP.plateCurved.dat(aMat)}:ZL_OBJECT));
	    OM.reg_(OP.pipeSmall			, aMat, aRegistry.add("Small " + aMat.getLocal() + " Fluid Pipe"			, "Fluid Pipes"				, aID+ 1, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   0, NBT_DIAMETER, PIXELS_POS[ 6], NBT_CONTACTDAMAGE, aContactDamage, NBT_CAPACITY, aStat* 2, NBT_GASPROOF, aGasProof), aRecipe?new Object[]{" P ", "wzh"       , 'P', OP.plateCurved.dat(aMat)}:ZL_OBJECT));
	    OM.reg_(OP.pipeMedium			, aMat, aRegistry.add(aMat.getLocal() + " Fluid Pipe"						, "Fluid Pipes"				, aID+ 2, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   0, NBT_DIAMETER, PIXELS_POS[ 8], NBT_CONTACTDAMAGE, aContactDamage, NBT_CAPACITY, aStat* 6, NBT_GASPROOF, aGasProof), aRecipe?new Object[]{"PPP", "wzh"       , 'P', OP.plateCurved.dat(aMat)}:ZL_OBJECT));
	    OM.reg_(OP.pipeLarge			, aMat, aRegistry.add("Large " + aMat.getLocal() + " Fluid Pipe"			, "Fluid Pipes"				, aID+ 3, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   0, NBT_DIAMETER, PIXELS_POS[12], NBT_CONTACTDAMAGE, aContactDamage, NBT_CAPACITY, aStat*12, NBT_GASPROOF, aGasProof), aRecipe?new Object[]{"PPP", "wzh", "PPP", 'P', OP.plateCurved.dat(aMat)}:ZL_OBJECT));
	    OM.reg_(OP.pipeHuge				, aMat, aRegistry.add("Huge " + aMat.getLocal() + " Fluid Pipe"				, "Fluid Pipes"				, aID+ 4, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   0, NBT_DIAMETER, PIXELS_POS[16], NBT_CONTACTDAMAGE, aContactDamage, NBT_CAPACITY, aStat*24, NBT_GASPROOF, aGasProof), aRecipe?new Object[]{"PPP", "wzh", "PPP", 'P', OP.plateDouble.dat(aMat)}:ZL_OBJECT));
	}
	
	@Override
	public void readFromNBT2(NBTTagCompound aNBT) {
    	super.readFromNBT2(aNBT);
    	if (aNBT.hasKey("gt.mlast")) mLastReceivedFrom = aNBT.getByte("gt.mlast");
    	if (aNBT.hasKey("gt.mtransfer")) mTransferredAmount = aNBT.getLong("gt.mtransfer");
    	if (aNBT.hasKey(NBT_PIPERENDER)) mRenderType = aNBT.getByte(NBT_PIPERENDER);
    	if (aNBT.hasKey(NBT_GASPROOF)) mGasProof = aNBT.getBoolean(NBT_GASPROOF);
    	if (aNBT.hasKey(NBT_CAPACITY)) mTank.setCapacity(aNBT.getInteger(NBT_CAPACITY) * 2);
        if (aNBT.hasKey(NBT_TANK)) mTank.readFromNBT(aNBT.getCompoundTag(NBT_TANK));
	}
	
	@Override
	public void writeToNBT2(NBTTagCompound aNBT) {
    	super.writeToNBT2(aNBT);
		aNBT.setByte("gt.mlast", mLastReceivedFrom);
        aNBT.setTag(NBT_TANK, mTank.writeToNBT(new NBTTagCompound()));
        UT.NBT.setNumber(aNBT, "gt.mtransfer", mTransferredAmount);
	}
	
	@Override
	public void addToolTips(List aList, ItemStack aStack, boolean aF3_H) {
		aList.add(Chat.CYAN		+ LH.get(LH.PIPE_STATS_BANDWIDTH) + (mTank.getCapacity()/4) + " L/t");
		aList.add(Chat.CYAN		+ LH.get(LH.PIPE_STATS_CAPACITY) + mTank.getCapacity() + " L");
		aList.add(Chat.DRED		+ LH.get(LH.HAZARD_MELTDOWN) + " (" + getTemperatureMax(SIDE_ANY) + " K)");
		if (!mGasProof		) aList.add(Chat.DRED		+ LH.get(LH.HAZARD_LEAKING_GAS));
		if (mContactDamage	) aList.add(Chat.DRED		+ LH.get(LH.HAZARD_CONTACT));
		super.addToolTips(aList, aStack, aF3_H);
	}
	
    @Override
    public void onTick2(long aTimer, boolean aIsServerSide) {
    	super.onTick2(aTimer, aIsServerSide);
    	
	    if (aIsServerSide && ((aTimer % 2 == 0) != UT.Worlds.areCoordsEven(this))) {
	    	mTransferredAmount = 0;
	    	
	    	FluidStack tFluid = mTank.getFluid();
	    	
	    	if (mTank.getFluidAmount() > 0) {
	    		mTemperature = UT.Fluids.temperature(tFluid);
	    		if (!mGasProof && UT.Fluids.gas(tFluid)) {
	    			mTransferredAmount += Math.min(8, mTank.getFluidAmount());
	    			mTank.drain(8, T);
	    			UT.Sounds.send(worldObj, SFX.MC_FIZZ, 1.0F, 1.0F, getCoords());
	    			try {for (Entity tEntity : (ArrayList<Entity>)worldObj.getEntitiesWithinAABB(Entity.class, AxisAlignedBB.getBoundingBox(xCoord-2, yCoord-2, zCoord-2, xCoord+3, yCoord+3, zCoord+3))) UT.Entities.applyTemperatureDamage(tEntity, mTemperature, 2.0F);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	    		}
	    	} else {
	    		long tEnvTemp = UT.Worlds.getEnvironmentalTemperature(worldObj, xCoord, yCoord, zCoord);
	    		if (mTemperature < tEnvTemp) mTemperature++; else if (mTemperature > tEnvTemp) mTemperature--;
	    	}
	    	
    		if (mTemperature > getTemperatureMax(SIDE_ANY)) {setOnFire(); if (getRandomNumber(100) == 0) {setToFire(); return;}}
    		
			distribute(ALL_SIDES_VALID);
			
			if (aTimer > 2) mLastReceivedFrom = 0;
		}
    }
    
    public void distribute(byte[] aSides) {
    	ArrayListNoNulls<DelegatorTileEntity<IFluidHandler>> tAdjacentTanks = new ArrayListNoNulls<DelegatorTileEntity<IFluidHandler>>(), tAdjacentPipes = new ArrayListNoNulls<DelegatorTileEntity<IFluidHandler>>();
		DelegatorTileEntity<IFluidHandler> tTank;
		
		long tAmount = mTank.getFluidAmount();
		if (tAmount <= 0) return;
		byte tPipeCount = 1;
		
    	for (byte aSide : aSides) if (canEmitFluidsTo(aSide) && !FACE_CONNECTED[aSide][mLastReceivedFrom] && (!hasCovers() || mCovers.mBehaviours[aSide] == null || !mCovers.mBehaviours[aSide].interceptFluidDrain(aSide, mCovers, aSide, mTank.getFluid()))) {
			tTank = getAdjacentTank(aSide);
			if (tTank.mTileEntity != null) {
				if (tTank.mTileEntity instanceof MultiTileEntityPipeFluid) {
					if (((MultiTileEntityPipeFluid)tTank.mTileEntity).mTank.getFluidAmount() < mTank.getFluidAmount()) {
						tAmount += ((MultiTileEntityPipeFluid)tTank.mTileEntity).mTank.getFluidAmount();
						tPipeCount++;
						tAdjacentTanks.add(tTank);
					}
				} else if (tTank.mTileEntity.fill(tTank.getForgeSideOfTileEntity(), mTank.getFluid(), F) > 0) {
					tAdjacentTanks.add(tTank);
				}
			} else {
				if (tTank.getBlock() instanceof BlockCauldron) {
					byte tMeta = tTank.getMetaData();
					if (tMeta < 3 && UT.Fluids.water(mTank.getFluid()) && mTank.getFluidAmount() >= 334) {
						mTank.drain(334, T);
						tTank.setMetaData((byte)(tMeta + 1));
					}
				}
			}
		}
    	
    	if (tAmount % tPipeCount == 0) {
        	tAmount /= tPipeCount;
    	} else {
        	tAmount /= tPipeCount;
        	tAmount++;
    	}
    	
	   	if (tAmount > 0) for (int i = tAdjacentTanks.size(); i > 0 && mTank.getFluidAmount() > 0;) {
	    	tTank = tAdjacentTanks.get(--i);
		    if (tTank.mTileEntity instanceof MultiTileEntityPipeFluid) {
		    	tAdjacentTanks.remove(i);
		    	tAdjacentPipes.add(tTank);
		    	int tDrained = tTank.mTileEntity.fill(tTank.getForgeSideOfTileEntity(), mTank.drain(UT.Code.bindInt(tAmount-((MultiTileEntityPipeFluid)tTank.mTileEntity).mTank.getFluidAmount()), F), T);
				mTransferredAmount += tDrained;
		    	mTank.drain(tDrained, T);
		    }
	    }
	   	
		if (!tAdjacentTanks.isEmpty()) {
			tAmount = mTank.getFluidAmount() / tAdjacentTanks.size();
			if (tAmount <= 0) {
				while (mTank.getFluidAmount() > 0 && !tAdjacentTanks.isEmpty()) {
					tAdjacentTanks.remove(tTank = tAdjacentTanks.get(getRandomNumber(tAdjacentTanks.size())));
					int tDrained = tTank.mTileEntity.fill(tTank.getForgeSideOfTileEntity(), mTank.drain(1, F), T);
					mTransferredAmount += tDrained;
					mTank.drain(tDrained, T);
				}
			} else {
				for (DelegatorTileEntity<IFluidHandler> tTank2 : tAdjacentTanks) {
					int tDrained = tTank2.mTileEntity.fill(tTank2.getForgeSideOfTileEntity(), mTank.drain(UT.Code.bindInt(tAmount), F), T);
					mTransferredAmount += tDrained;
					mTank.drain(tDrained, T);
				}
			}
		}
		
		if (!tAdjacentPipes.isEmpty() && mTank.getFluidAmount() > mTank.getCapacity() / 2) {
			tAmount = (mTank.getFluidAmount() - mTank.getCapacity() / 2) / tAdjacentPipes.size();
			if (tAmount > 0) {
				for (DelegatorTileEntity<IFluidHandler> tTank2 : tAdjacentPipes) {
					int tDrained = tTank2.mTileEntity.fill(tTank2.getForgeSideOfTileEntity(), mTank.drain(UT.Code.bindInt(tAmount), F), T);
					mTransferredAmount += tDrained;
					mTank.drain(tDrained, T);
				}
			}
		}
    }
    
	@Override public boolean canDrop(int aInventorySlot) {return F;}
	
	@Override public void onEntityCollidedWithBlock(Entity aEntity) {if (mContactDamage) UT.Entities.applyTemperatureDamage(aEntity, mTemperature, 1.0F);}
	
	@Override protected IFluidTank getFluidTankFillable2 (byte aSide, FluidStack aFluidToFill ) {return SIDES_INVALID[aSide] || canAcceptFluidsFrom	(aSide) ? mTank : null;}
	@Override protected IFluidTank getFluidTankDrainable2(byte aSide, FluidStack aFluidToDrain) {return SIDES_INVALID[aSide] || canEmitFluidsTo		(aSide) ? mTank : null;}
	@Override protected IFluidTank[] getFluidTanks2(byte aSide) {return new IFluidTank[] {mTank};}
	@Override public int fill(ForgeDirection aDirection, FluidStack aFluid, boolean aDoFill) {if (aDoFill) mLastReceivedFrom |= SBIT[UT.Code.side(aDirection)]; return super.fill(aDirection, aFluid, aDoFill);}
	
	public boolean canEmitFluidsTo							(byte aSide) {return connected(aSide);}
	public boolean canAcceptFluidsFrom						(byte aSide) {return connected(aSide);}
	
	@Override public boolean canConnect						(byte aSide, DelegatorTileEntity<TileEntity> aDelegator) {return (mTank.getCapacity() >= 250 && aDelegator.getBlock() instanceof BlockCauldron) || (aDelegator.mTileEntity instanceof IFluidHandler && UT.Code.exists(0, ((IFluidHandler)aDelegator.mTileEntity).getTankInfo(aDelegator.getForgeSideOfTileEntity())));}
	
	@Override public long getGibblValue						(byte aSide) {return mTank.getFluidAmount();}
	@Override public long getGibblMax						(byte aSide) {return mTank.getCapacity();}
	
	@Override public long getProgressValue					(byte aSide) {return mTransferredAmount / 2;}
	@Override public long getProgressMax					(byte aSide) {return mTank.getCapacity() / 2;}
	
	@Override public long getTemperatureValue				(byte aSide) {return mTemperature;}
	@Override public long getTemperatureMax					(byte aSide) {return (long)(mMaterial.mMeltingPoint * HEAT_RESISTANCE_BONUS);}
	
	@Override public ITexture getTextureSide				(byte aSide, byte aConnections, float aDiameter, int aRenderPass) {BlockTextureDefault tBase = BlockTextureDefault.get(mMaterial, getIconIndexSide		(aSide, aConnections, aDiameter, aRenderPass), mIsGlowing, mRGBa); switch(mRenderType) {case 1: return BlockTextureMulti.get(tBase, BlockTextureDefault.get(Textures.BlockIcons.PIPE_RESTRICTOR)); default: return tBase;}}
	@Override public ITexture getTextureConnected			(byte aSide, byte aConnections, float aDiameter, int aRenderPass) {BlockTextureDefault tBase = BlockTextureDefault.get(mMaterial, getIconIndexConnected	(aSide, aConnections, aDiameter, aRenderPass), mIsGlowing, mRGBa); switch(mRenderType) {case 1: return BlockTextureMulti.get(tBase, BlockTextureDefault.get(Textures.BlockIcons.PIPE_RESTRICTOR)); default: return tBase;}}
	
	@Override public int getIconIndexSide					(byte aSide, byte aConnections, float aDiameter, int aRenderPass) {return IconsGT.INDEX_BLOCK_PIPE_SIDE;}
	@Override public int getIconIndexConnected				(byte aSide, byte aConnections, float aDiameter, int aRenderPass) {return aDiameter<0.37F?OP.pipeTiny.mIconIndexBlock:aDiameter<0.49F?OP.pipeSmall.mIconIndexBlock:aDiameter<0.74F?OP.pipeMedium.mIconIndexBlock:aDiameter<0.99F?OP.pipeLarge.mIconIndexBlock:OP.pipeHuge.mIconIndexBlock;}
	
	@Override public Collection<TagData> getConnectorTypes	(byte aSide) {return TD.Connectors.PIPE_FLUID.AS_LIST;}
	
	@Override public String getFacingTool() {return TOOL_wrench;}
	
	@Override public String getTileEntityName() {return "gt.multitileentity.connector.pipe.fluid";}
}